﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.3
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "JobMain"
	
	Private ABMPageId As String = ""

	Dim UserType  As String
	Dim UserId As Int

	Dim jobid As Int
	Dim boxordernum As Int =0
	Dim idcreative As Int =0
	Dim cartontype As String =""

	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!
	BuildPage
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	'----------------------MODIFICATION-------------------------------
	'log("connected")
	ws = WebSocket1
	ABMPageId = ABM.GetPageID(page, Name,ws)
	DateTime.DateFormat="dd/MM/yyyy"
	DateTime.timeFormat="HH:mm"
	Log("*PAGE: " & Name & " ***" & ws.Session.GetAttribute("authName") & "@" & ABMShared.timestamp)
	
'	Dim txt As String
'	txt=ws.UpgradeRequest.GetParameter("prmtr")
'	If txt.Length>0 Then
'		jobid=txt.SubString2(0,txt.Length-1)
'	End If

	
	Dim session As HttpSession = ABM.GetSession(ws, ABMShared.SessionMaxInactiveIntervalSeconds)
	If session.IsNew Then
		session.Invalidate
		ABMShared.NavigateToPage(ws, "", "./")
		Return
	End If

	If ABMShared.NeedsAuthorization Then
		If session.GetAttribute2("IsAuthorized", "") = "" Then
			ABMShared.NavigateToPage(ws, ABMPageId, "../")
			Return
		End If
	End If
	
	ABM.UpdateFromCache(Me, ABMShared.CachedPages, ABMPageId, ws)
	If page.ComesFromPageCache Then
		' when we have a page that is cached it doesn't matter if it comes or not from a new connection we serve the cached version.
		'log("comes from cache")
		page.Refresh
		page.FinishedLoading
	Else
		If page.WebsocketReconnected Then
			'log("websocket reconnected")
			' when we have a client that doesn't have the page in cache and it's websocket reconnected and also it's session is new - basically when the client
			' had internet problems and it's session (and also cache) expired before he reconnected so the user has content in the browser but we don't have
			' any on the server. So we need to reload the page.
			' when a client that doesn't have the page in cache and it's websocket reconnected but it's session is not new - when the client had internet
			' problems and when he reconnected it's session was valid but he had no cache for this page we need to reload the page as the user browser has
			' content, reconnected but we have no content in cache
			ABMShared.NavigateToPage (ws, ABMPageId, "./" & page.PageHTMLName)
		Else
			' when the client did not reconnected it doesn't matter if the session was new or not because this is the websockets first connection so no dynamic
			' content in the browser ... we are going to serve the dynamic content...
			'log("websocket first connection")
			page.Prepare
			ConnectPage
		End If
	End If
	'log("abmPageId)
	'----------------------MODIFICATION-------------------------------



	
	UserType = session.GetAttribute2("UserType", "0")
	
	If UserType<>"PRINTERS" Then
		ABMShared.NavigateToPage(ws, ABMPageId,"../")
		Return
	End If
	UserId = session.GetAttribute2("UserID", "0")
	
	
	
		
	' Headers for tables
	'tblPress
	Dim SQL As SQL=DBM.GetSQL
'	Dim works As List = DBM.SQLSelect(SQL, "SELECT TOP 1 * FROM JOBMAIN")
'	Dim tblFields As Map = works.Get(0)
'	Dim i As Int
'	Dim tblPress As ABMTable = page.Component("tblPress")
'	Dim Headers(tblFields.Size), Themes(tblFields.Size), Datafields(tblFields.Size) As  String
'	Dim Visible(tblFields.Size), Sortable(tblFields.Size) As  Boolean
'	Dim Heights(tblFields.Size) As Int
'	Dim coltitle As String
'	For i=0 To tblFields.Size-1
'		coltitle=tblFields.GetKeyAt(i)
'		Headers(i)=coltitle.ToUpperCase
'		Themes(i)="bg"
'		Heights(i)=0
'		Visible(i)=True
'		Sortable(i)=False
'		Datafields(i)=""
'	Next
'	tblPress.SetHeaders(Headers)
'	tblPress.SetHeaderThemes(Themes)
'	tblPress.SetHeaderHeights(Heights)
'	tblPress.SetColumnVisible(Visible)
'	tblPress.SetColumnSortable(Sortable)
'	tblPress.SetColumnDataFields(Datafields)
'	
	
	
	
	
'	Dim tblWorks As ABMTable = page.Component("tblOrders")
'	
'	' Headers for tblWorks
'	Dim works As List = DBM.SQLSelect(SQL, "SELECT TOP 1 * FROM STORAGEDBJOBSTOPRINT")
'	Dim tblFields As Map = works.Get(0)
'	Dim i As Int
'	Dim Headers(tblFields.Size), Themes(tblFields.Size), Datafields(tblFields.Size) As  String
'	Dim Visible(tblFields.Size), Sortable(tblFields.Size) As  Boolean
'	Dim Heights(tblFields.Size) As Int
'	Dim coltitle As String
'	For i=0 To tblFields.Size-1
'		coltitle=tblFields.GetKeyAt(i)
'		Headers(i)=coltitle.ToUPPERCASE
'		Themes(i)="bg"
'		Heights(i)=0
'		Visible(i)=True
'		Sortable(i)=False
'		Datafields(i)=""
'	Next
'	tblWorks.SetHeaders(Headers)
'	tblWorks.SetHeaderThemes(Themes)
'	tblWorks.SetHeaderHeights(Heights)
'	tblWorks.SetColumnVisible(Visible)
'	tblWorks.SetColumnSortable(Sortable)
'	tblWorks.SetColumnDataFields(Datafields)
'	
	
	
	
	DBM.CloseSQL(SQL)

	
	
	
	
	
	page.restoreNavigationBarPosition
	page.savenavigationbarposition
	page.NavigationBar.Clear
	ABMShared.UpdateNavigationBar(page,  UserType,UserId)
	page.NavigationBar.REFRESH
	page.RestoreNavigationBarPosition
		
	
'	page.NavigationBar.Title="ΕΝΤΟΛΗ " & jobid
'	page.NavigationBar.Refresh
	'LoadJobMainData
	'LoadPress
End Sub

public Sub ConnectPage()

	Dim lblData As ABMLabel
	lblData.Initialize(page,"lblData","",ABM.SIZE_H5,False,"DataLabel")
	page.Cell(1,1).AddComponent(lblData)

	Dim atable As ABMTable
	atable.Initialize(page,"atable",False, False, True,"tbltheme")
	page.Cell(2,1).AddComponent(atable)

	

	
	
	' refresh the page
	page.Refresh
	' Tell the browser we finished loading
	page.FinishedLoading
	' restoring the navigation bar position
	page.RestoreNavigationBarPosition 'used to be in the depreciated Page_Ready() event!
End Sub


Private Sub WebSocket_Disconnected
	'log("Disconnected")
End Sub

Sub Page_ParseEvent(Params As Map)
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
	If eventName = "beforeunload" Then
		'log("preparing for url refresh")
		ABM.RemoveMeFromCache(ABMShared.CachedPages, ABMPageId)
		Return
	End If
	If SubExists(Me, eventName) Then
		Params.Remove("eventname")
		Params.Remove("eventparams")
		Select Case Params.Size
			Case 0
				CallSub(Me, eventName)
			Case 1
				CallSub2(Me, eventName, Params.Get(eventParams(0)))
			Case 2
				If Params.get(eventParams(0)) = "abmistable" Then
					Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
					CallSub2(Me, eventName, PassedTables)
				Else
					CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
				End If
			Case Else
				' cannot be called diretly, to many param
				CallSub2(Me, eventName, Params)
		End Select
	End If
End Sub


public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(ABMShared.MyTheme)
	
	' add additional themes specific for this page
	theme.AddTableTheme("tbltheme")
	theme.Table("tbltheme").ZDepth = ABM.ZDEPTH_1
	
	theme.Table("tbltheme").AddCellTheme("bg")
	theme.Table("tbltheme").Cell("bg").BackColor = ABM.COLOR_BLUEGREY
	theme.Table("tbltheme").Cell("bg").ForeColor = ABM.COLOR_WHITE
	
	theme.Table("tbltheme").AddCellTheme("bgr")
	theme.Table("tbltheme").Cell("bgr").BackColor = ABM.COLOR_BLUEGREY
	theme.Table("tbltheme").Cell("bgr").ForeColor = ABM.COLOR_WHITE
	theme.Table("tbltheme").Cell("bgr").Align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
	
	theme.Table("tbltheme").AddCellTheme("bgc")
	theme.Table("tbltheme").Cell("bgc").BackColor = ABM.COLOR_BLUEGREY
	theme.Table("tbltheme").Cell("bgc").ForeColor = ABM.COLOR_WHITE
	theme.Table("tbltheme").Cell("bgc").Align = ABM.TABLECELL_HORIZONTALALIGN_CENTER
	
	theme.Table("tbltheme").AddCellTheme("nocolor")
	theme.Table("tbltheme").Cell("nocolor").ActiveBackColor = ABM.COLOR_BLUEGREY
	theme.Table("tbltheme").Cell("nocolor").ActiveBackColorIntensity = ABM.INTENSITY_LIGHTEN2
	
	theme.Table("tbltheme").AddCellTheme("nocolor0")
	theme.Table("tbltheme").Cell("nocolor0").ActiveBackColor = ABM.COLOR_ORANGE
	theme.Table("tbltheme").Cell("nocolor0").ActiveBackColorIntensity = ABM.INTENSITY_LIGHTEN3
	theme.Table("tbltheme").Cell("nocolor0").BackColor = ABM.COLOR_CYAN
	theme.Table("tbltheme").Cell("nocolor0").BackColorIntensity = ABM.INTENSITY_LIGHTEN5
	
	theme.Table("tbltheme").AddCellTheme("nocolor1")
	theme.Table("tbltheme").Cell("nocolor1").ActiveBackColor = ABM.COLOR_ORANGE
	theme.Table("tbltheme").Cell("nocolor1").ActiveBackColorIntensity = ABM.INTENSITY_LIGHTEN3
	theme.Table("tbltheme").Cell("nocolor1").BackColor = ABM.COLOR_CYAN
	theme.Table("tbltheme").Cell("nocolor1").BackColorIntensity = ABM.INTENSITY_LIGHTEN3
	
	theme.Table("tbltheme").AddCellTheme("nocolor2")
	theme.Table("tbltheme").Cell("nocolor2").ActiveBackColor = ABM.COLOR_BLUE
	theme.Table("tbltheme").Cell("nocolor2").ActiveBackColorIntensity = ABM.INTENSITY_LIGHTEN3
	theme.Table("tbltheme").Cell("nocolor2").BackColor = ABM.COLOR_RED
	theme.Table("tbltheme").Cell("nocolor2").BackColorIntensity = ABM.INTENSITY_LIGHTEN5
	
	theme.Table("tbltheme").AddCellTheme("nocolor3")
	theme.Table("tbltheme").Cell("nocolor3").ActiveBackColor = ABM.COLOR_BLUE
	theme.Table("tbltheme").Cell("nocolor3").ActiveBackColorIntensity = ABM.INTENSITY_LIGHTEN3
	theme.Table("tbltheme").Cell("nocolor3").BackColor = ABM.COLOR_RED
	theme.Table("tbltheme").Cell("nocolor3").BackColorIntensity = ABM.INTENSITY_LIGHTEN3
	
		
	' add additional themes specific for this page
	theme.AddButtonTheme("bigblue")
	theme.Button("bigblue").BackColor = ABM.COLOR_LIGHTBLUE
	
	theme.AddButtonTheme("bigred")
	theme.Button("bigred").BackColor = ABM.COLOR_red
	
	' modal sheet
	theme.AddContainerTheme("modalcontent")
	theme.Container("modalcontent").BackColor = ABM.COLOR_WHITE
	
	' modal sheet
	theme.AddContainerTheme("modalfooter")
	theme.Container("modalfooter").BackColor = ABM.COLOR_LIGHTBLUE
	
	theme.AddLabelTheme("DataLabel")
	theme.Label("DataLabel").BackColor=ABM.COLOR_ORANGE
	theme.Label("DataLabel").BackColorINTENSITY=ABM.INTENSITY_LIGHTEN5
	
End Sub

public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & ABMShared.AppName & "/" & Name, False, 120,  theme)
	page.ShowLoader=True
	page.PageTitle = "Εντολή Εκτύπωσης"
	page.PageDescription = "Εντολή Εκτύπωσης"
	page.PageHTMLName = "index.html"
	page.PageKeywords = ""
	page.PageSiteMapPriority = ""
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_YEARLY
	page.PageCharset=Main.charset
	page.PageLanguage="el"
		
	ABMShared.BuildNavigationBar(page, "Εντολή", "../images/logo.png", "Users", "", "")

	page.AddRows(2,True,"").AddCells12(1,"")
	'page.AddRows(1,	True,"").AddCellsOS(1,0,0,0,6,6,6,"").AddCellsOS(1,0,0,0,6,6,6,"")
	'page.AddRows(1,	True,"").AddCellsOS(1,0,0,0,6,6,6,"").AddCellsOS(1,0,0,0,6,6,6,"")
	page.BuildGrid ' IMPORTANT!

End Sub

' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	page.SaveNavigationBarPosition
	If Action = "LogOff" Then
		ABMShared.LogOff(page)
		Return
	End If	
	ABMShared.NavigateToPage(ws, ABMPageId, Value)
End Sub


private Sub LoadJobMainData
'	Dim SQL As SQL = DBM.GetSQL
'	Dim sb As StringBuilder
'	Dim txt As String
'	sb.Initialize
'	Dim rs As ResultSet = SQL.ExecQuery2("SELECT * FROM [JOBMAIN] WHERE JOBNUM=?", Array As String(jobid))
'	Do While rs.NextRow 
'		idcreative=rs.GetInt("IDCREATIVE")
'		boxordernum=rs.GetInt("BOXORDERNUM")		
'		cartontype=rs.GetString("ΤΥΠΟΣ ΧΑΡΤΟΝΙ")		
'		sb.append(rs.GetString("ΠΕΛΑΤΗΣ")).Append(CRLF).APPEND("{C:#0000AA}{B}").Append(rs.GetString("ΠΕΡΙΓΡΑΦΗ")).APPEND("{/B}{/C}").Append(CRLF)
'		If Not(rs.GetString("ΑΝΤΙΤΥΠΑ")=Null) Then
'			sb.Append("ΑΝΤΙΤΥΠΑ: ").APPEND(rs.GetString("ΑΝΤΙΤΥΠΑ")).Append(CRLF)
'		End If
'		If Not(rs.GetString("ΠΑΡΑΤΗΡΗΣΕΙΣ2")=Null) Then
'			txt=rs.GetString("ΠΑΡΑΤΗΡΗΣΕΙΣ2")
'		Else	
'			txt="-"
'		End If		
'		sb.Append("ΕΙΔΙΚΕΣ ΟΔΗΓΙΕΣ: ").APPEND("{C:#BB0000}{B}").APPEND(txt).APPEND("{/B}{/C}").Append(CRLF)
'		sb.APPEND("{C:#00BB00}{B}").Append(rs.GetString("ΤΥΠΟΣ ΧΑΡΤΙΟΥ")).Append(", ").Append(rs.GetString("ΒΑΡΟΣ ΧΑΡΤΙΟΥ")).Append("gsm, ")
'		sb.Append(rs.GetString("ΔΙΑΣΤΑΣΗ ΕΚΤΥΠΩΣΗΣ")).APPEND("{/B}{/C}").Append(CRLF)
'		sb.Append("ΕΞΩ: {B}").APPEND(rs.GetString("ΕΞΩΕΠΕΞ")).Append("{/B}, ΜΕΣΑ: {B}").Append(rs.GetString("ΜΕΣΑΕΠΕΞ")).Append("{/B}"& CRLF)
'		sb.Append("ΚΩΔΙΚΟΣ ΕΡΓΑΣΙΑΣ: ").APPEND("{C:#0000BB}{B}").Append(rs.GetString("MASTERJOBNUM")).APPEND("{/B}{/C}").Append(CRLF)
'		If rs.GETINT("ΚΟΠΗ") = 0 Then 
'			sb.Append("ΕΠΟΜΕΝΟ ΣΤΑΔΙΟ: {C:#AA0000}{B}ΕΠΕΞΕΡΓΑΣΙΑ{/B}{/C}")
'		Else
'			sb.Append("ΕΠΟΜΕΝΟ ΣΤΑΔΙΟ: {C:#AA0000}{B}ΚΟΠΗ{/B}{/C}")
'		End If
'	Loop
'	DBM.CloseSQL(SQL)
'	Dim lbldata As ABMLabel = page.component("lblData")
'	lbldata.Text=sb.tostring
'	lbldata.refresh
'	page.REFRESH
	
End Sub







